#ifndef __DECLARE_H
#define __DECLARE_H

#include "../src/offender.h" 
#include "hero.h"
#include "aliens.h"
#include "misc.h"
#include "numbers.h"
#include "power_ups.h"
#include "powerup_display.h"
#include "backgrounds.h"

/* sprite definitions used for sequences  */
struct sprite sprite_bullet[] = {
	{ bullet_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_hero[] = {
	{ hero_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_galien[] = {
	{ galien_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_laser[] = {
	{ laser_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_tank[] = {
	{ tank_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_blob[] = {
	{ blob_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_balien[] = {
	{ blalien_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_star[] = {
	{ star_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_cloak[] = {
	{ cloak_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_ralien[] = {
	{ ralien1_xpm, NULL, NULL },
	{ ralien1_xpm, NULL, NULL },
	{ ralien1_xpm, NULL, NULL },
	{ ralien2_xpm, NULL, NULL },
	{ ralien2_xpm, NULL, NULL },
	{ ralien2_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};
struct sprite sprite_kami[] = {
	{ kami1_xpm, NULL, NULL },
	{ kami1_xpm, NULL, NULL },
	{ kami1_xpm, NULL, NULL },
	{ kami2_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};
struct sprite sprite_explo[] = {
	{ explo1_xpm, NULL, NULL },
	{ explo2_xpm, NULL, NULL },
	{ explo3_xpm, NULL, NULL },
	{ explo4_xpm, NULL, NULL },
	{ explo5_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};
struct sprite sprite_nums[] = {
        { _0_xpm, NULL, NULL },
	{ _1_xpm, NULL, NULL },
	{ _2_xpm, NULL, NULL },
	{ _3_xpm, NULL, NULL },
	{ _4_xpm, NULL, NULL },
	{ _5_xpm, NULL, NULL },
	{ _6_xpm, NULL, NULL },
	{ _7_xpm, NULL, NULL },
	{ _8_xpm, NULL, NULL },
	{ _9_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

/*****************************************************
 * ********   POWER UP SECTION ***********************
 * ***************************************************/

struct sprite sprite_rocket_pup[] = {
	{ rocket1_pup_xpm, NULL, NULL },
	{ rocket2_pup_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_rocket_fire[] = {
	{ rocket1_fire_xpm, NULL, NULL },
	{ rocket2_fire_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_heats_pup[] = {
	{ heat1_pup_xpm, NULL, NULL },
	{ heat2_pup_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_heats_fire[] = {
	{ heat1_1_fire_xpm, NULL, NULL },
	{ heat1_2_fire_xpm, NULL, NULL },
	{ heat2_1_fire_xpm, NULL, NULL },
	{ heat2_2_fire_xpm, NULL, NULL },
	{ heat3_1_fire_xpm, NULL, NULL },
	{ heat3_2_fire_xpm, NULL, NULL },
	{ heat4_1_fire_xpm, NULL, NULL },
	{ heat4_2_fire_xpm, NULL, NULL },
	{ heat5_1_fire_xpm, NULL, NULL },
	{ heat5_2_fire_xpm, NULL, NULL },
	{ heat6_1_fire_xpm, NULL, NULL },
	{ heat6_2_fire_xpm, NULL, NULL },
	{ heat7_1_fire_xpm, NULL, NULL },
	{ heat7_2_fire_xpm, NULL, NULL },
	{ heat8_1_fire_xpm, NULL, NULL },
	{ heat8_2_fire_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};



/* POWER UP DISPLAY */

struct sprite sprite_display_h[] = {
	{ display_h_xpm, NULL, NULL },
	{ display_h_s_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};
struct sprite sprite_display_r[] = {
	{ display_r_xpm, NULL, NULL },
	{ display_r_s_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};
struct sprite sprite_display_g[] = {
	{ display_g_xpm, NULL, NULL },
	{ display_g_s_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

struct sprite sprite_backgrounds[] = {
	{ startscreen_xpm, NULL, NULL },
	{ bgrock_xpm, NULL, NULL },
	{ pausescreen_xpm, NULL, NULL },
	{ getreadyscreen_xpm, NULL, NULL },
	{ NULL, NULL, NULL }
};

#endif
