/*
 * Copyright (C) 2007 silas albrecht and dylan albrecht.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "offender.h"
#include "ui.h"

gint cur_level = 0;

#define A_PER_ROW	21

gint offender_levels[NUM_LEVELS][A_PER_ROW] = {
	 { RALIEN,  RALIEN,  RALIEN,  RALIEN,  RALIEN,  RALIEN,  RALIEN,
           BALIEN,  BALIEN,  BALIEN,  BALIEN,  BALIEN,  BALIEN,  BALIEN,
           BLOB,    BALIEN,  GALIEN,  BALIEN,  GALIEN,  BALIEN,  GALIEN
         },
	 { KAMI,    RALIEN,  RALIEN,  BALIEN,  RALIEN,  RALIEN,  KAMI,
	   GALIEN,  BALIEN,  KAMI,    KAMI,    KAMI,    BALIEN,  GALIEN,
	   GALIEN,  BALIEN,  GALIEN,  BALIEN,  GALIEN,  BALIEN,  GALIEN
	 },
	 { RALIEN,  RALIEN,  RALIEN,  RALIEN,  RALIEN,  RALIEN,  RALIEN,
	   KAMI,    KAMI,    KAMI,    KAMI,    KAMI,    KAMI,    KAMI,
	   GALIEN,  BALIEN,  GALIEN,  BALIEN,  GALIEN,  BALIEN,  GALIEN
	 },
	 { KAMI,    KAMI,    KAMI,    KAMI,    KAMI,    KAMI,    KAMI,
	   KAMI,    KAMI,    KAMI,    BALIEN,  KAMI,    KAMI,    KAMI,
	   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,
	 },
	 { BALIEN,  BALIEN,  BALIEN,  BALIEN,  BALIEN,  BALIEN,  BALIEN,
	   BLOB,    KAMI,    BLOB,    BLOB,    BLOB,    KAMI,    BLOB,
	   KAMI,    KAMI,    KAMI,    KAMI,    KAMI,    KAMI,    KAMI
	 },
	 { RALIEN,  RALIEN,  KAMI,    KAMI,    KAMI,    RALIEN,  RALIEN,
 	   BLOB,    BLOB,    BALIEN,  GALIEN,  BALIEN,  BLOB,    BLOB,
	   CLOAK,   CLOAK,   GALIEN,  GALIEN,  GALIEN,  CLOAK,   CLOAK
	 },
	 { BLOB,    BLOB,    BLOB,    KAMI,    BLOB,    BLOB,    BLOB,
	   BLOB,    KAMI,    BLOB,    BLOB,    BLOB,    KAMI,    BLOB,
	   BLOB,    BLOB,    BLOB,    KAMI,    BLOB,    BLOB,    BLOB
	 },
	 { CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,
	   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,
	   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,   CLOAK,
	 },
};

void skel_level(gint alien_type[])
{
	int y, x, n = 0;
	int x_space = 40;
	struct a_type *type = type_find(alien_type[0]);
	int start = (SCREEN_WIDTH - x_space * 6) / 2 - 
			(type->width / 2) + STRAFE_DIST/2;
	int end = start + x_space * 6;

	/* collumns for aliens (every 30 starting at 20) */
	for(y = 20; y <= 80; y += 30)
		/* rows for aliens (every x_space starting at 60) */
		for(x = start, n; x <= end && n <= A_PER_ROW; x += x_space, n++)
			make_unit(x, y, 0, 0, alien_type[n], 0, 0);
}

void load_level(int x)
{
	if (x == NUM_LEVELS) {
		pop_up_win ("You Win!", "You Win!!");
		new_game();
		return;
	}

	g_assert(0 <= x && x < NUM_LEVELS);

	rm_type_from_list(ALIENS | BULLET | LASER | POWERUPS | WEAPONS, 0);
	player->y = P1_START_Y;
	player->x = P1_START_X;
	skel_level(offender_levels[x]);
	cur_level = x;

	background->seq = LEVELONESEQNUM;
}

inline void new_game()
{
	player->health = conf->start_lives;

	/* remove all powerup weapons obtained */
	free_all_weapons(player);

	/* update the alien configed default values */
	update_types();

	load_level(conf->start_level-1);
	/* errg  .. ugly */
	if (game_mode == PAUSED)
		switch_game_mode (PLAYING);
}

void game_over()
{
	switch_game_mode (STARTSCREEN);
	background->y = 0;
}

inline void next_level()
{
	load_level(cur_level + 1);
}

void init_level()
{
        struct a_type *a = type_find(TANK);
        struct unit *lt, *rt;
        lt = make_unit(0, 0, 0, 0, TANK, 0, 0);
        rt = make_unit(SCREEN_WIDTH - a->width, 0, 0, 0, TANK, 0, 0);
        gtk_timeout_add(2000, tank_shoot, (gpointer) lt);
        gtk_timeout_add(2000, tank_shoot, (gpointer) rt);
	/* player health display*/
	a = type_find(NUM);
	make_unit(SCREEN_WIDTH - a->width, SCREEN_HEIGHT - a->height - 5,
			0,0,NUM,player->health-1,0);
	/* player weapon display always in same spot */

	a = type_find (GUN_DSP);
	make_unit (5, SCREEN_HEIGHT - a->height - 5, 0, 0, GUN_DSP,
			1, 7);

	a = type_find (ROCKET_DSP);
	make_unit (5 + 1 * a->width, SCREEN_HEIGHT - a->height - 5,
			0, 0, ROCKET_DSP, 1, 7);

	a = type_find (HEAT_S_DSP);
	make_unit (5 + 2 * a->width, SCREEN_HEIGHT - a->height - 5,
			0, 0, HEAT_S_DSP, 1, 7);
}
