/*
 * Copyright (C) 2007 silas albrecht and dylan albrecht.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "ui.h"
#include "offender.h"
#include <gtk/gtk.h>

void do_the_fricken_pause()
{
	switch_game_mode(PAUSED);
}

/* format: {"/File/tearoff1", "accelkey", func, arg, "type" }, */
static GtkItemFactoryEntry menu_items[] = {
  {"/_Game",		NULL,		0,		0, "<Branch>"	  },
  {"/Game/tearoff1",	NULL,		0,              0, "<Tearoff>"	  },
  {"/Game/_New Game",	"<control>N",	new_game,	0		  },
  {"/Game/_Pause",	"<control>P",	do_the_fricken_pause, 0, 
	  "<CheckItem>"  },
  {"/Game/_Configure",	NULL,		config_make,	0,		  }, 
  {"/Game/sep1",	NULL,		0,		0, "<Separator>"  },
  {"/Game/_Quit",	"<control>Q",	gtk_main_quit,	0		  },
 
  {"/_Help",		NULL,		0,		0, "<LastBranch>" },
  {"/Help/tearoff1",	NULL,		0,		0, "<Tearoff>"	  },
  {"/Help/_About",	NULL,		about_window,	0		  },
  {"/Help/_Game Help",	"<control>H",	game_help,	0		  },
};

void create_item_factory (GtkWidget *box1, GtkWidget *window)
{
	static int nr_items = sizeof (menu_items) / sizeof (menu_items[0]);

	GtkAccelGroup *accel_group = gtk_accel_group_new ();
	GtkItemFactory *item_factory = gtk_item_factory_new (GTK_TYPE_MENU_BAR, 
							 "<menu>", accel_group);

	gtk_item_factory_create_items(item_factory, nr_items, menu_items, NULL);
	gtk_accel_group_attach(accel_group, GTK_OBJECT (window));

	/* put menu on the vertical packing box */
	gtk_box_pack_start (GTK_BOX (box1),
			gtk_item_factory_get_widget (item_factory, "<menu>"),
			FALSE, FALSE, 0);

	/* show it, show it ALL!! */
	gtk_widget_show_all (window);
}

static inline void close_dia_win (GtkWidget *widget, gpointer data)
{
	gtk_widget_destroy ((GtkWidget *) data);
}

/* pop_up_win - Makes a window with a label and title and slaps an 
 * OK button on there.
 */
void pop_up_win (char *title, char *label)
{
	GtkWidget *my_label;
	GtkWidget *button;
	GtkWidget *dialog_window;

	/* Create a dialog window */
	dialog_window = gtk_dialog_new ();

	gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy",
	GTK_SIGNAL_FUNC (gtk_grab_remove), dialog_window);

	gtk_window_set_title (GTK_WINDOW (dialog_window), title);
	gtk_container_border_width (GTK_CONTAINER (dialog_window), 0);
	button = gtk_button_new_with_label ("OK");

	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			GTK_SIGNAL_FUNC (close_dia_win), dialog_window);

	/*  Default the "Ok" button */
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->action_area), 
				button, TRUE, TRUE, 0);
	gtk_widget_grab_default (button);
	gtk_widget_show (button);

	my_label = gtk_label_new (label);

	gtk_misc_set_padding (GTK_MISC (my_label), 10, 10);

	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox), 
				my_label, TRUE, TRUE, 0);

	gtk_widget_show (my_label);
	gtk_widget_show (dialog_window);

	/* Only this window can have actions done. */
	gtk_grab_add (dialog_window);
}

void about_window()
{
	pop_up_win ("About", "\
offender - A 2D space shooter.\n\n\
Copyright (C) 2001 silas albrecht and dylan albrecht.\n\
Licensed under the the terms of the GNU General Public License\n\
Authors listed in the AUTHORS file, license in LICENSE..\n\n\
Official Website: http://offender.sourceforge.net/");
}

void game_help()
{
	pop_up_win("Game Help",
			"Sorry, Not Implemented Yet.\nGo write some? ;)");
}
